﻿
  { *** OP_Code_CB *** }



  { *************************** }
  { *** Untergruppen von 11 *** }
  { *************************** }




{ *** OP_Code_CB *** }



{ CB CB CB CB CB CB CB CB CB CB CB CB }





  procedure OP_Code_CB_00;
  var
    ziel_reg, OP_Code2,
    Wert_n : Byte;
    Wert_Word : Word;
  begin

    OP_Code2 := OP_Code AND %00111000;

    case OP_Code2 of



      // RLC r = Rotate Left with Carry
      %00000000 : begin

                    ziel_reg :=  OP_Code AND %00000111;

                    case ziel_reg of



                      // RLC A
                      %00000111 : begin

                                    if (mod_cpu.Reg.HRS.A and %10000000) = %10000000 then begin

                                      // Rotation von A und setzen Bit 0 (da Bit 7 vorher 1 war)
                                      mod_cpu.Reg.HRS.A := (mod_cpu.Reg.HRS.A shl 1) or %00000001;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von A und ruecksetzen Bit 0 (da Bit 7 vorher 0 war)
                                      mod_cpu.Reg.HRS.A := (mod_cpu.Reg.HRS.A shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.A and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.A);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RLC A';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.A:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RLC A




                      // RLC B
                      %00000000 : begin

                                    if (mod_cpu.Reg.HRS.B and %10000000) = %10000000 then begin

                                      // Rotation von B und setzen Bit 0 (da Bit 7 vorher 1 war)
                                      mod_cpu.Reg.HRS.B := (mod_cpu.Reg.HRS.B shl 1) or %00000001;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von B und ruecksetzen Bit 0 (da Bit 7 vorher 0 war)
                                      mod_cpu.Reg.HRS.B := (mod_cpu.Reg.HRS.B shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.B and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.B);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RLC B';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.B:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RLC B



                      // RLC C
                      %00000001 : begin

                                    if (mod_cpu.Reg.HRS.C and %10000000) = %10000000 then begin

                                      // Rotation von C und setzen Bit 0 (da Bit 7 vorher 1 war)
                                      mod_cpu.Reg.HRS.C := (mod_cpu.Reg.HRS.C shl 1) or %00000001;

                                      // CF is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von C und ruecksetzen Bit 0 (da Bit 7 vorher 0 war)
                                      mod_cpu.Reg.HRS.C := (mod_cpu.Reg.HRS.C shl 1) and %11111110;

                                      // CF is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.C and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.C);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RLC C';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.C:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RLC C



                      // RLC D
                      %00000010 : begin

                                    if (mod_cpu.Reg.HRS.D and %10000000) = %10000000 then begin

                                      // Rotation von D und setzen Bit 0 (da Bit 7 vorher 1 war)
                                      mod_cpu.Reg.HRS.D := (mod_cpu.Reg.HRS.D shl 1) or %00000001;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von D und ruecksetzen Bit 0 (da Bit 7 vorher 0 war)
                                      mod_cpu.Reg.HRS.D := (mod_cpu.Reg.HRS.D shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.D and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.D);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RLC D';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.D:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RLC D



                      // RLC E
                      %00000011 : begin

                                    if (mod_cpu.Reg.HRS.E and %10000000) = %10000000 then begin

                                      // Rotation von E und setzen Bit 0 (da Bit 7 vorher 1 war)
                                      mod_cpu.Reg.HRS.E := (mod_cpu.Reg.HRS.E shl 1) or %00000001;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von E und ruecksetzen Bit 0 (da Bit 7 vorher 0 war)
                                      mod_cpu.Reg.HRS.E := (mod_cpu.Reg.HRS.E shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.E and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.E);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RLC E';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.E:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RLC E



                      // RLC H
                      %00000100 : begin

                                    if (mod_cpu.Reg.HRS.H and %10000000) = %10000000 then begin

                                      // Rotation von H und setzen Bit 0 (da Bit 7 vorher 1 war)
                                      mod_cpu.Reg.HRS.H := (mod_cpu.Reg.HRS.H shl 1) or %00000001;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von H und ruecksetzen Bit 0 (da Bit 7 vorher 0 war)
                                      mod_cpu.Reg.HRS.H := (mod_cpu.Reg.HRS.H shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.H and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.H);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RLC H';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.H:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RLC H



                      // RLC L
                      %00000101 : begin

                                    if (mod_cpu.Reg.HRS.L and %10000000) = %10000000 then begin

                                      // Rotation von L und setzen Bit 0 (da Bit 7 vorher 1 war)
                                      mod_cpu.Reg.HRS.L := (mod_cpu.Reg.HRS.L shl 1) or %00000001;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von L und ruecksetzen Bit 0 (da Bit 7 vorher 0 war)
                                      mod_cpu.Reg.HRS.L := (mod_cpu.Reg.HRS.L shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.L and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.L);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RLC L';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.L:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RLC L




                      // RLC (HL)
                      %00000110 : begin

                                    Wert_Word := (mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L;
                                    Wert_n := mod_ram.Read_Byte(Wert_Word); // (HL) -> Wert_n

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin
                                      Form_RAM.setze_Mem_Red(Wert_Word);    // HL
                                    end;
                                    {$ENDIF}

                                    if (Wert_n and %10000000) = %10000000 then begin

                                      // Rotation von Wert_n und setzen Bit 0 (da Bit 7 vorher 1 war)
                                      Wert_n := (Wert_n shl 1) or %00000001;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von Wert_n und ruecksetzen Bit 0 (da Bit 7 vorher 0 war)
                                      Wert_n := (Wert_n shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (Wert_n and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(Wert_n);
                                    mod_ram.Write_Byte(Wert_Word, Wert_n);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RLC (HL)';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.HL_Inhalt:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RLC (HL)




                    end; { case ziel_reg of }

                  end; { RLC r }








      // RL r = Rotate Left
      %00010000 : begin

                    ziel_reg :=  OP_Code AND %00000111;

                    Wert_n := mod_cpu.Reg.HRS.F and %00000001;

                    case ziel_reg of


                      // RL A
                      %00000111 : begin

                                    // Merken von Bit 7 -> CY
                                    if (mod_cpu.Reg.HRS.A and %10000000) = %10000000 then begin

                                      // Links-Rotation von A und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.A := (mod_cpu.Reg.HRS.A shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.A := (mod_cpu.Reg.HRS.A shl 1) and %11111110;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Links-Rotation von A und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.A := (mod_cpu.Reg.HRS.A shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.A := (mod_cpu.Reg.HRS.A shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.A and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.A);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RL A';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.A:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RL A




                      // RL B
                      %00000000 : begin

                                    if (mod_cpu.Reg.HRS.B and %10000000) = %10000000 then begin

                                      // Rotation von B und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.B := (mod_cpu.Reg.HRS.B shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.B := (mod_cpu.Reg.HRS.B shl 1) and %11111110;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von B und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.B := (mod_cpu.Reg.HRS.B shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.B := (mod_cpu.Reg.HRS.B shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.B and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.B);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RL B';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.B:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RL B


                      // RL C
                      %00000001 : begin

                                    if (mod_cpu.Reg.HRS.C and %10000000) = %10000000 then begin

                                      // Rotation von C und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.C := (mod_cpu.Reg.HRS.C shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.C := (mod_cpu.Reg.HRS.C shl 1) and %11111110;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von C und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.C := (mod_cpu.Reg.HRS.C shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.C := (mod_cpu.Reg.HRS.C shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.C and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.C);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RL C';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.C:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RL C


                      // RL D
                      %00000010 : begin

                                    if (mod_cpu.Reg.HRS.D and %10000000) = %10000000 then begin

                                      // Rotation von D und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.D := (mod_cpu.Reg.HRS.D shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.D := (mod_cpu.Reg.HRS.D shl 1) and %11111110;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von D und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.D := (mod_cpu.Reg.HRS.D shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.D := (mod_cpu.Reg.HRS.D shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.D and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.D);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RL D';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.D:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RL D



                      // RL E
                      %00000011 : begin

                                    if (mod_cpu.Reg.HRS.E and %10000000) = %10000000 then begin

                                      // Rotation von E und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.E := (mod_cpu.Reg.HRS.E shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.E := (mod_cpu.Reg.HRS.E shl 1) and %11111110;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von E und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.E := (mod_cpu.Reg.HRS.E shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.E := (mod_cpu.Reg.HRS.E shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.E and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.E);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RL E';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.E:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RL E



                      // RL H
                      %00000100 : begin

                                    if (mod_cpu.Reg.HRS.H and %10000000) = %10000000 then begin

                                      // Rotation von H und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.H := (mod_cpu.Reg.HRS.H shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.H := (mod_cpu.Reg.HRS.H shl 1) and %11111110;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von H und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.H := (mod_cpu.Reg.HRS.H shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.H := (mod_cpu.Reg.HRS.H shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.H and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.H);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RL H';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.H:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RL H



                      // RL L
                      %00000101 : begin

                                    if (mod_cpu.Reg.HRS.L and %10000000) = %10000000 then begin

                                      // Rotation von L und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.L := (mod_cpu.Reg.HRS.L shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.L := (mod_cpu.Reg.HRS.L shl 1) and %11111110;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von L und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.L := (mod_cpu.Reg.HRS.L shl 1) or %00000001
                                      else
                                        mod_cpu.Reg.HRS.L := (mod_cpu.Reg.HRS.L shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.L and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.L);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RL L';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.L:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RL L



                      // RL (HL)
                      %00000110 : begin

                                    Wert_Word := (mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L;
                                    Wert_n := mod_ram.Read_Byte(Wert_Word); // (HL) -> Wert_n

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin
                                      Form_RAM.setze_Mem_Red(Wert_Word);    // HL
                                    end;
                                    {$ENDIF}

                                    if (Wert_n and %10000000) = %10000000 then begin

                                      // Rotation von Wert_n und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        Wert_n := (Wert_n shl 1) or %00000001
                                      else
                                        Wert_n := (Wert_n shl 1) and %11111110;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rotation von Wert_n und setzen CY -> Bit 0
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        Wert_n := (Wert_n shl 1) or %00000001
                                      else
                                        Wert_n := (Wert_n shl 1) and %11111110;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (Wert_n and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(Wert_n);
                                    mod_ram.Write_Byte(Wert_Word, Wert_n);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RL (HL)';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.HL_Inhalt:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RL (HL)

                    end; { case ziel_reg of }

                  end; { RL r }




      // RR r = Rotate Right
      %00011000 : begin

                    ziel_reg :=  OP_Code AND %00000111;

                    Wert_n := mod_cpu.Reg.HRS.F and %00000001;

                    case ziel_reg of


                      // RR A
                      %00000111 : begin

                                    // Merken von Bit 0 -> CY
                                    if (mod_cpu.Reg.HRS.A and %00000001) = %00000001 then begin

                                      // Rechts-Rotation von A und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.A := (mod_cpu.Reg.HRS.A shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.A := (mod_cpu.Reg.HRS.A shr 1) and %01111111;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rechts-Rotation von A und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.A := (mod_cpu.Reg.HRS.A shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.A := (mod_cpu.Reg.HRS.A shr 1) and %01111111;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.A and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.A);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RR A';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.A:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RR A



                      // RR B
                      %00000000 : begin

                                    // Merken von Bit 0 -> CY
                                    if (mod_cpu.Reg.HRS.B and %00000001) = %00000001 then begin

                                      // Rechts-Rotation von B und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.B := (mod_cpu.Reg.HRS.B shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.B := (mod_cpu.Reg.HRS.B shr 1) and %01111111;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rechts-Rotation von B und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.B := (mod_cpu.Reg.HRS.B shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.B := (mod_cpu.Reg.HRS.B shr 1) and %01111111;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.B and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.B);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RR B';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.B:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RR B



                      // RR C
                      %00000001 : begin

                                    // Merken von Bit 0 -> CY
                                    if (mod_cpu.Reg.HRS.C and %00000001) = %00000001 then begin

                                      // Rechts-Rotation von C und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.C := (mod_cpu.Reg.HRS.C shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.C := (mod_cpu.Reg.HRS.C shr 1) and %01111111;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rechts-Rotation von C und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.C := (mod_cpu.Reg.HRS.C shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.C := (mod_cpu.Reg.HRS.C shr 1) and %01111111;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.C and %10000000) = %10000000 then }

                                    {
                                    CY Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.C);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RR C';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.C:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RR C



                      // RR D
                      %00000010 : begin

                                    // Merken von Bit 0 -> CY
                                    if (mod_cpu.Reg.HRS.D and %00000001) = %00000001 then begin

                                      // Rechts-Rotation von D und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.D := (mod_cpu.Reg.HRS.D shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.D := (mod_cpu.Reg.HRS.D shr 1) and %01111111;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rechts-Rotation von D und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.D := (mod_cpu.Reg.HRS.D shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.D := (mod_cpu.Reg.HRS.D shr 1) and %01111111;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.D and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.D);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RR D';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.D:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RR D



                      // RR E
                      %00000011 : begin

                                    // Merken von Bit 0 -> CY
                                    if (mod_cpu.Reg.HRS.E and %00000001) = %00000001 then begin

                                      // Rechts-Rotation von A und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.E := (mod_cpu.Reg.HRS.E shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.E := (mod_cpu.Reg.HRS.E shr 1) and %01111111;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rechts-Rotation von E und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.E := (mod_cpu.Reg.HRS.E shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.E := (mod_cpu.Reg.HRS.E shr 1) and %01111111;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.E and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.E);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RR E';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.E:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RR E



                      // RR H
                      %00000100 : begin

                                    // Merken von Bit 0 -> CY
                                    if (mod_cpu.Reg.HRS.H and %00000001) = %00000001 then begin

                                      // Rechts-Rotation von H und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.H := (mod_cpu.Reg.HRS.H shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.H := (mod_cpu.Reg.HRS.H shr 1) and %01111111;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rechts-Rotation von H und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.H := (mod_cpu.Reg.HRS.H shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.H := (mod_cpu.Reg.HRS.H shr 1) and %01111111;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.H and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.H);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RR H';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.H:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RR H



                      // RR L
                      %00000101 : begin

                                    // Merken von Bit 0 -> CY
                                    if (mod_cpu.Reg.HRS.L and %00000001) = %00000001 then begin

                                      // Rechts-Rotation von L und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.L := (mod_cpu.Reg.HRS.L shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.L := (mod_cpu.Reg.HRS.L shr 1) and %01111111;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rechts-Rotation von L und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        mod_cpu.Reg.HRS.L := (mod_cpu.Reg.HRS.L shr 1) or %10000000
                                      else
                                        mod_cpu.Reg.HRS.L := (mod_cpu.Reg.HRS.L shr 1) and %01111111;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (mod_cpu.Reg.HRS.L and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.L);


                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RR L';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.L:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RR L



                      // RR (HL)
                      %00000110 : begin

                                    Wert_Word := (mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L;
                                    Wert_n := mod_ram.Read_Byte(Wert_Word); // (HL) -> Wert_n

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin
                                      Form_RAM.setze_Mem_Red(Wert_Word);    // HL
                                    end;
                                    {$ENDIF}

                                    // Merken von Bit 0 -> CY
                                    if (Wert_n and %00000001) = %00000001 then begin

                                      // Rechts-Rotation von Wert_n und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        Wert_n := (Wert_n shr 1) or %10000000
                                      else
                                        Wert_n := (Wert_n shr 1) and %01111111;

                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001; { Set CF }

                                    end
                                    else begin

                                      // Rechts-Rotation von Wert_n und setzen CY -> Bit 7
                                      if (mod_cpu.Reg.HRS.F and %00000001) = %00000001 then
                                        Wert_n := (Wert_n shr 1) or %10000000
                                      else
                                        Wert_n := (Wert_n shr 1) and %01111111;

                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    end; { if (Wert_n and %10000000) = %10000000 then }

                                    {
                                    C Data from bit 7 of the source.
                                    }

                                    setze_Flags_ROTATE(Wert_n);
                                    mod_ram.Write_Byte(Wert_Word, Wert_n);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'RR (HL)';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.HL:=Farbe_Lesen;
                                      Form_cpu.Reg_Red.HRS.HL_Inhalt:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // RR (HL)



                    end; { case ziel_reg of }

                  end; { RR r }





      // SLA r = Shift Left Arithmetic
      %00100000 : begin

                    ziel_reg :=  OP_Code AND %00000111;

                    Wert_n := mod_cpu.Reg.HRS.F and %00000001;

                    case ziel_reg of


                      // SLA A
                      %00000111 : begin

                                    // CY is data from bit 7 of source register
                                    if (mod_cpu.Reg.HRS.A and %10000000) = %10000000 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    // SLA A
                                    mod_cpu.Reg.HRS.A := mod_cpu.Reg.HRS.A shl 1;

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.A);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SLA A';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.A:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SLA A



                      // SLA B
                      %00000000 : begin

                                    // CY is data from bit 7 of source register
                                    if (mod_cpu.Reg.HRS.B and %10000000) = %10000000 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    // SLA B
                                    mod_cpu.Reg.HRS.B := mod_cpu.Reg.HRS.B shl 1;

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.B);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SLA B';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.B:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SLA B



                      // SLA C
                      %00000001 : begin

                                    // CY is data from bit 7 of source register
                                    if (mod_cpu.Reg.HRS.C and %10000000) = %10000000 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    // SLA C
                                    mod_cpu.Reg.HRS.C := mod_cpu.Reg.HRS.C shl 1;

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.C);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SLA C';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.C:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SLA C



                      // SLA D
                      %00000010 : begin

                                    // CY is data from bit 7 of source register
                                    if (mod_cpu.Reg.HRS.D and %10000000) = %10000000 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    // SLA B
                                    mod_cpu.Reg.HRS.D := mod_cpu.Reg.HRS.D shl 1;

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.D);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SLA D';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.D:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SLA D



                      // SLA E
                      %00000011 : begin

                                    // CY is data from bit 7 of source register
                                    if (mod_cpu.Reg.HRS.E and %10000000) = %10000000 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    // SLA E
                                    mod_cpu.Reg.HRS.E := mod_cpu.Reg.HRS.E shl 1;

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.E);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SLA E';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.E:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SLA E



                      // SLA H
                      %00000100 : begin

                                    // CY is data from bit 7 of source register
                                    if (mod_cpu.Reg.HRS.H and %10000000) = %10000000 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    // SLA H
                                    mod_cpu.Reg.HRS.H := mod_cpu.Reg.HRS.H shl 1;

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.H);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SLA H';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.H:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SLA H



                      // SLA L
                      %00000101 : begin

                                    // CY is data from bit 7 of source register
                                    if (mod_cpu.Reg.HRS.L and %10000000) = %10000000 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    // SLA L
                                    mod_cpu.Reg.HRS.L := mod_cpu.Reg.HRS.L shl 1;

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.L);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SLA L';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.L:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SLA L



                      // SLA (HL)
                      %00000110 : begin

                                    Wert_Word := (mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L;
                                    Wert_n := mod_ram.Read_Byte(Wert_Word); // (HL) -> Wert_n

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin
                                      Form_RAM.setze_Mem_Red(Wert_Word);    // HL
                                    end;
                                    {$ENDIF}


                                    // CY is data from bit 7 of source register
                                    if (Wert_n and %10000000) = %10000000 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                    // SLA Wert_n
                                    Wert_n := Wert_n shl 1;

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(Wert_n);

                                    // Wert_n -> (HL)
                                    mod_ram.Write_Byte(Wert_Word, Wert_n);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SLA (HL)';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.HL:=Farbe_Lesen;
                                      Form_cpu.Reg_Red.HRS.HL_Inhalt:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SLA (HL)



                    end; { case ziel_reg of }

                  end; { SLA r }





      // SRA r = Shift Right Arithmetic
      %00101000 : begin

                    ziel_reg :=  OP_Code AND %00000111;

                    Wert_n := mod_cpu.Reg.HRS.F and %00000001;

                    case ziel_reg of


                      // SRA A
                      %00000111 : begin

                                    // merken von Bit 7 des Registers A
                                    if (mod_cpu.Reg.HRS.A and %10000000) = %10000000 then begin

                                      // *** hier Bit 7 = 1

                                      // CY wird nach Bit 0 des Registers A gesetzt
                                      if (mod_cpu.Reg.HRS.A and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA A
                                      mod_cpu.Reg.HRS.A := mod_cpu.Reg.HRS.A shr 1;

                                      // setzen von Bit 7 des Registers A (war vorher auch 1)
                                      mod_cpu.Reg.HRS.A := mod_cpu.Reg.HRS.A or %10000000; { Set bit 7 }

                                    end
                                    else begin

                                      // *** hier Bit 7 = 0

                                      // CY wird nach Bit 0 des Registers A gesetzt
                                      if (mod_cpu.Reg.HRS.A and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA A
                                      mod_cpu.Reg.HRS.A := mod_cpu.Reg.HRS.A shr 1;

                                      // Ruecksetzen von Bit 7 des Registers A (war vorher auch 0)
                                      mod_cpu.Reg.HRS.A := mod_cpu.Reg.HRS.A and %01111111; { Reset bit 7 }

                                    end; { if (mod_cpu.Reg.HRS.A and %10000000) = %10000000 then }

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.A);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRA A';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.A:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRA A



                      // SRA B
                      %00000000 : begin

                                    // merken von Bit 7 des Registers B
                                    if (mod_cpu.Reg.HRS.B and %10000000) = %10000000 then begin

                                      // *** hier Bit 7 = 1

                                      // CY wird nach Bit 0 des Registers B gesetzt
                                      if (mod_cpu.Reg.HRS.B and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA B
                                      mod_cpu.Reg.HRS.B := mod_cpu.Reg.HRS.B shr 1;

                                      // setzen von Bit 7 des Registers B (war vorher auch 1)
                                      mod_cpu.Reg.HRS.B := mod_cpu.Reg.HRS.B or %10000000; { Set bit 7 }

                                    end
                                    else begin

                                      // *** hier Bit 7 = 0

                                      // CY wird nach Bit 0 des Registers B gesetzt
                                      if (mod_cpu.Reg.HRS.B and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA B
                                      mod_cpu.Reg.HRS.B := mod_cpu.Reg.HRS.B shr 1;

                                      // Ruecksetzen von Bit 7 des Registers B (war vorher auch 0)
                                      mod_cpu.Reg.HRS.B := mod_cpu.Reg.HRS.B and %01111111; { Reset bit 7 }

                                    end; { if (mod_cpu.Reg.HRS.B and %10000000) = %10000000 then }

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.B);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRA B';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.B:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRA B



                      // SRA C
                      %00000001 : begin

                                    // merken von Bit 7 des Registers C
                                    if (mod_cpu.Reg.HRS.C and %10000000) = %10000000 then begin

                                      // *** hier Bit 7 = 1

                                      // CY wird nach Bit 0 des Registers C gesetzt
                                      if (mod_cpu.Reg.HRS.C and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA C
                                      mod_cpu.Reg.HRS.C := mod_cpu.Reg.HRS.C shr 1;

                                      // setzen von Bit 7 des Registers C (war vorher auch 1)
                                      mod_cpu.Reg.HRS.C := mod_cpu.Reg.HRS.C or %10000000 { Set bit 7 }

                                    end
                                    else begin

                                      // *** hier Bit 7 = 0

                                      // CY wird nach Bit 0 des Registers C gesetzt
                                      if (mod_cpu.Reg.HRS.C and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA C
                                      mod_cpu.Reg.HRS.C := mod_cpu.Reg.HRS.C shr 1;

                                      // Ruecksetzen von Bit 7 des Registers C (war vorher auch 0)
                                      mod_cpu.Reg.HRS.C := mod_cpu.Reg.HRS.C and %01111111; { Reset bit 7 }

                                    end; { if (mod_cpu.Reg.HRS.C and %10000000) = %10000000 then }

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.C);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRA C';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.C:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRA C



                      // SRA D
                      %00000010 : begin

                                    // merken von Bit 7 des Registers D
                                    if (mod_cpu.Reg.HRS.D and %10000000) = %10000000 then begin

                                      // *** hier Bit 7 = 1

                                      // CY wird nach Bit 0 des Registers D gesetzt
                                      if (mod_cpu.Reg.HRS.D and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA D
                                      mod_cpu.Reg.HRS.D := mod_cpu.Reg.HRS.D shr 1;

                                      // setzen von Bit 7 des Registers D (war vorher auch 1)
                                      mod_cpu.Reg.HRS.D := mod_cpu.Reg.HRS.D or %10000000 { Set bit 7 }

                                    end
                                    else begin

                                      // *** hier Bit 7 = 0

                                      // CY wird nach Bit 0 des Registers D gesetzt
                                      if (mod_cpu.Reg.HRS.D and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA D
                                      mod_cpu.Reg.HRS.D := mod_cpu.Reg.HRS.D shr 1;

                                      // Ruecksetzen von Bit 7 des Registers D (war vorher auch 0)
                                      mod_cpu.Reg.HRS.D := mod_cpu.Reg.HRS.D and %01111111; { Reset bit 7 }

                                    end; { if (mod_cpu.Reg.HRS.D and %10000000) = %10000000 then }

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.D);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRA D';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.D:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRA D



                      // SRA E
                      %00000011 : begin

                                    // merken von Bit 7 des Registers E
                                    if (mod_cpu.Reg.HRS.E and %10000000) = %10000000 then begin

                                      // *** hier Bit 7 = 1

                                      // CY wird nach Bit 0 des Registers E gesetzt
                                      if (mod_cpu.Reg.HRS.E and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA C
                                      mod_cpu.Reg.HRS.E := mod_cpu.Reg.HRS.E shr 1;

                                      // setzen von Bit 7 des Registers E (war vorher auch 1)
                                      mod_cpu.Reg.HRS.E := mod_cpu.Reg.HRS.E or %10000000 { Set bit 7 }

                                    end
                                    else begin

                                      // *** hier Bit 7 = 0

                                      // CY wird nach Bit 0 des Registers E gesetzt
                                      if (mod_cpu.Reg.HRS.E and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA E
                                      mod_cpu.Reg.HRS.E := mod_cpu.Reg.HRS.E shr 1;

                                      // Ruecksetzen von Bit 7 des Registers E (war vorher auch 0)
                                      mod_cpu.Reg.HRS.E := mod_cpu.Reg.HRS.E and %01111111; { Reset bit 7 }

                                    end; { if (mod_cpu.Reg.HRS.E and %10000000) = %10000000 then }

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.E);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRA E';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.E:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRA E




                      // SRA H
                      %00000100 : begin

                                    // merken von Bit 7 des Registers H
                                    if (mod_cpu.Reg.HRS.H and %10000000) = %10000000 then begin

                                      // *** hier Bit 7 = 1

                                      // CY wird nach Bit 0 des Registers H gesetzt
                                      if (mod_cpu.Reg.HRS.H and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA H
                                      mod_cpu.Reg.HRS.H := mod_cpu.Reg.HRS.H shr 1;

                                      // setzen von Bit 7 des Registers H (war vorher auch 1)
                                      mod_cpu.Reg.HRS.H := mod_cpu.Reg.HRS.H or %10000000 { Set bit 7 }

                                    end
                                    else begin

                                      // *** hier Bit 7 = 0

                                      // CY wird nach Bit 0 des Registers H gesetzt
                                      if (mod_cpu.Reg.HRS.H and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA H
                                      mod_cpu.Reg.HRS.H := mod_cpu.Reg.HRS.H shr 1;

                                      // Ruecksetzen von Bit 7 des Registers H (war vorher auch 0)
                                      mod_cpu.Reg.HRS.H := mod_cpu.Reg.HRS.H and %01111111; { Reset bit 7 }

                                    end; { if (mod_cpu.Reg.HRS.H and %10000000) = %10000000 then }

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.H);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRA H';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.H:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRA H




                      // SRA L
                      %00000101 : begin

                                    // merken von Bit 7 des Registers L
                                    if (mod_cpu.Reg.HRS.L and %10000000) = %10000000 then begin

                                      // *** hier Bit 7 = 1

                                      // CY wird nach Bit 0 des Registers L gesetzt
                                      if (mod_cpu.Reg.HRS.C and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA L
                                      mod_cpu.Reg.HRS.L := mod_cpu.Reg.HRS.L shr 1;

                                      // setzen von Bit 7 des Registers L (war vorher auch 1)
                                      mod_cpu.Reg.HRS.L := mod_cpu.Reg.HRS.L or %10000000 { Set bit 7 }

                                    end
                                    else begin

                                      // *** hier Bit 7 = 0

                                      // CY wird nach Bit 0 des Registers L gesetzt
                                      if (mod_cpu.Reg.HRS.C and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA L
                                      mod_cpu.Reg.HRS.L := mod_cpu.Reg.HRS.L shr 1;

                                      // Ruecksetzen von Bit 7 des Registers L (war vorher auch 0)
                                      mod_cpu.Reg.HRS.L := mod_cpu.Reg.HRS.L and %01111111; { Reset bit 7 }

                                    end; { if (mod_cpu.Reg.HRS.L and %10000000) = %10000000 then }

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.L);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRA L';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.L:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRA L



                      // SRA (HL)
                      %00000110 : begin

                                    Wert_Word := (mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L;
                                    Wert_n := mod_ram.Read_Byte(Wert_Word); // (HL) -> Wert_n

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin
                                      Form_RAM.setze_Mem_Red(Wert_Word);    // HL
                                    end;
                                    {$ENDIF}

                                    // merken von Bit 7 des Wert_n
                                    if (Wert_n and %10000000) = %10000000 then begin

                                      // *** hier Bit 7 = 1

                                      // CY wird nach Bit 0 des Wert_n gesetzt
                                      if (Wert_n and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA Wert_n
                                      Wert_n := Wert_n shr 1;

                                      // setzen von Bit 7 des Wert_n (war vorher auch 1)
                                      Wert_n := Wert_n or %10000000 { Set bit 7 }

                                    end
                                    else begin

                                      // *** hier Bit 7 = 0

                                      // CY wird nach Bit 0 des Wert_n gesetzt
                                      if (Wert_n and %00000001) = %00000001 then
                                        // CY is set
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                      else
                                        // CY is reset
                                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }

                                      // SRA Wert_n
                                      Wert_n := Wert_n shr 1;

                                      // Ruecksetzen von Bit 7 des Wert_n (war vorher auch 0)
                                      Wert_n := Wert_n and %01111111; { Reset bit 7 }

                                    end; { if (Wert_n and %10000000) = %10000000 then }

                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(Wert_n);
                                    mod_ram.Write_Byte(Wert_Word, Wert_n);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRA (HL)';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.HL_Inhalt:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRA (HL)



                    end; { case ziel_reg of }

                  end; { SRA r }



      // SRL r = Shift Right Logical
      %00111000 : begin

                    ziel_reg :=  OP_Code AND %00000111;

                    Wert_n := mod_cpu.Reg.HRS.F and %00000001;

                    case ziel_reg of


                      // SRL A
                      %00000111 : begin

                                    // CY wird nach Bit 0 des Registers A gesetzt
                                    if (mod_cpu.Reg.HRS.A and %00000001) = %00000001 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }


                                    // SRL A
                                    mod_cpu.Reg.HRS.A := mod_cpu.Reg.HRS.A shr 1;


                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.A);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRL A';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.A:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRL A



                      // SRL B
                      %00000000 : begin

                                    // CY wird nach Bit 0 des Registers B gesetzt
                                    if (mod_cpu.Reg.HRS.B and %00000001) = %00000001 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }


                                    // SRL B
                                    mod_cpu.Reg.HRS.B := mod_cpu.Reg.HRS.B shr 1;


                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.B);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRL B';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.B:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRL B



                      // SRL C
                      %00000001 : begin

                                    // CY wird nach Bit 0 des Registers C gesetzt
                                    if (mod_cpu.Reg.HRS.C and %00000001) = %00000001 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }


                                    // SRL C
                                    mod_cpu.Reg.HRS.C := mod_cpu.Reg.HRS.C shr 1;


                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.C);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRL C';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.C:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRL C



                      // SRL D
                      %00000010 : begin

                                    // CY wird nach Bit 0 des Registers D gesetzt
                                    if (mod_cpu.Reg.HRS.D and %00000001) = %00000001 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }


                                    // SRL D
                                    mod_cpu.Reg.HRS.D := mod_cpu.Reg.HRS.D shr 1;


                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.D);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRL D';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.D:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRL D



                      // SRL E
                      %00000011 : begin

                                    // CY wird nach Bit 0 des Registers E gesetzt
                                    if (mod_cpu.Reg.HRS.E and %00000001) = %00000001 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }


                                    // SRL E
                                    mod_cpu.Reg.HRS.E := mod_cpu.Reg.HRS.E shr 1;


                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.E);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRL E';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.E:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRL E



                      // SRL H
                      %00000100 : begin

                                    // CY wird nach Bit 0 des Registers H gesetzt
                                    if (mod_cpu.Reg.HRS.H and %00000001) = %00000001 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }


                                    // SRL H
                                    mod_cpu.Reg.HRS.H := mod_cpu.Reg.HRS.H shr 1;


                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.H);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRL H';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.H:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRL H



                      // SRL L
                      %00000101 : begin

                                    // CY wird nach Bit 0 des Registers L gesetzt
                                    if (mod_cpu.Reg.HRS.L and %00000001) = %00000001 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }


                                    // SRL L
                                    mod_cpu.Reg.HRS.L := mod_cpu.Reg.HRS.L shr 1;


                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(mod_cpu.Reg.HRS.L);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRL L';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.L:=Farbe_Schreiben;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRL L



                      // SRL (HL)
                      %00000110 : begin

                                    Wert_Word := (mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L;
                                    Wert_n := mod_ram.Read_Byte(Wert_Word); // (HL) -> Wert_n

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin
                                      Form_RAM.setze_Mem_Red(Wert_Word);    // HL
                                    end;
                                    {$ENDIF}


                                    // CY wird nach Bit 0 des Wert_n gesetzt
                                    if (Wert_n and %00000001) = %00000001 then
                                      // CY is set
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000001 { Set CF }
                                    else
                                      // CY is reset
                                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111110; { Reset CF }


                                    // SRL Wert_n
                                    Wert_n := Wert_n shr 1;

                                    // Wert_n -> (HL)
                                    mod_ram.Write_Byte(Wert_Word, Wert_n);


                                    // FLAGS setzen ...
                                    setze_Flags_ROTATE(Wert_n);

                                    {$IFDEF mit_GUI}
                                    if Mode_Protokoll then begin

                                      Befehl_Zeile := 'SRL (HL)';

                                      Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.HL_Inhalt:=Farbe_Schreiben;
                                      Form_cpu.Reg_Red.HRS.HL:=Farbe_Lesen;

                                    end; { if Mode_Protokoll then }
                                    {$ENDIF}

                                    Befehl_abgearbeitet:=true;

                                  end; // SRL (HL)





                    end; { case ziel_reg of }

                  end; { SRL r }


    end; { case OP_Code2 of }



  end; { procedure OP_Code_CB_00 }









  procedure OP_Code_CB_01;
  var
    quell_reg, ziel_bit, var_quell_reg : Byte;
    Wert_Word : Word;
    quell_string : String;
  begin

    // BIT b, r
    quell_reg := OP_Code AND %00000111;
    quell_string:='???';

    case quell_reg of

      // BIT b, A
      %00000111 : begin
                      var_quell_reg := mod_cpu.Reg.HRS.A;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='A';
                        Form_cpu.Reg_Red.HRS.A:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // BIT b, A


      // BIT b, B
      %00000000 : begin
                      var_quell_reg := mod_cpu.Reg.HRS.B;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='B';
                        Form_cpu.Reg_Red.HRS.B:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // BIT b, B


      // BIT b, C
      %00000001 : begin
                      var_quell_reg := mod_cpu.Reg.HRS.C;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='C';
                        Form_cpu.Reg_Red.HRS.C:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // BIT b, C


      // BIT b, D
      %00000010 : begin
                      var_quell_reg := mod_cpu.Reg.HRS.D;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='D';
                        Form_cpu.Reg_Red.HRS.D:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // BIT b, D


      // BIT b, E
      %00000011 : begin
                      var_quell_reg := mod_cpu.Reg.HRS.E;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='E';
                        Form_cpu.Reg_Red.HRS.E:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // BIT b, E


      // BIT b, H
      %00000100 : begin
                      var_quell_reg := mod_cpu.Reg.HRS.H;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='H';
                        Form_cpu.Reg_Red.HRS.H:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // BIT b, H


      // BIT b, L
      %00000101 : begin
                      var_quell_reg := mod_cpu.Reg.HRS.L;
                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin
                        quell_string:='L';
                        Form_cpu.Reg_Red.HRS.L:=Farbe_Lesen;
                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // BIT b, L


      // BIT b, (HL)
      %00000110 : begin
                      Wert_Word := (mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L;
                      var_quell_reg := mod_ram.Read_Byte(Wert_Word); // (HL) -> Wert_n

                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        quell_string:='(HL)';
                        Form_RAM.setze_Mem_Red((mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L);
                        Form_cpu.Reg_Red.HRS.HL_Inhalt:=Farbe_Lesen;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}
                    end; // BIT b,(HL)



    end; { case quell_reg of }


    // BIT b, r
    ziel_bit := OP_Code AND %00111000;


    case ziel_bit of

        // BIT 0, r
        %00000000 : begin

                      {
                      S is unknown
                      Z is set if specified bit is 0; reset otherwise
                      H is set
                      P/V is unknown
                      N is reset
                      C is not affected
                      }

                      // SF - bei Bit 0..6 Reset (wie im Emulator)
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %01111111; { Reset SF }

                      // Z is set if specified bit is 0; reset otherwise
                      // P/V wie Z
                      if (var_quell_reg and %00000001) = 0 then begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %01000000; { Set ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000100; { Set PF }
                      end
                      else begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %10111111; { Reset ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111011; { Reset PF }
                      end;


                      // H is set
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00010000; { Set HF }

                      // N is reset
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111101; { Reset NF }


                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'BIT 0,'+quell_string;
                        Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}

                      Befehl_abgearbeitet:=true;

                    end; // BIT 0, r



        // BIT 1, r
        %00001000 : begin

                      {
                      S is unknown
                      Z is set if specified bit is 0; reset otherwise
                      H is set
                      P/V is unknown
                      N is reset
                      C is not affected
                      }

                      // SF - bei Bit 0..6 Reset (wie im Emulator)
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %01111111; { Reset SF }

                      // Z is set if specified bit is 0; reset otherwise
                      // P/V wie Z
                      if (var_quell_reg and %00000010) = 0 then begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %01000000; { Set ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000100; { Set PF }
                      end
                      else begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %10111111; { Reset ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111011; { Reset PF }
                      end;


                      // H is set
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00010000; { Set HF }

                      // N is reset
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111101; { Reset NF }


                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'BIT 1,'+quell_string;
                        Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}

                      Befehl_abgearbeitet:=true;

                    end; // BIT 1, r



        // BIT 2, r
        %00010000 : begin

                      {
                      S is unknown
                      Z is set if specified bit is 0; reset otherwise
                      H is set
                      P/V is unknown
                      N is reset
                      C is not affected
                      }

                      // SF - bei Bit 0..6 Reset (wie im Emulator)
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %01111111; { Reset SF }

                      // Z is set if specified bit is 0; reset otherwise
                      // P/V wie Z
                      if (var_quell_reg and %00000100) = 0 then begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %01000000; { Set ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000100; { Set PF }
                      end
                      else begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %10111111; { Reset ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111011; { Reset PF }
                      end;


                      // H is set
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00010000; { Set HF }

                      // N is reset
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111101; { Reset NF }


                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'BIT 2,'+quell_string;
                        Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}

                      Befehl_abgearbeitet:=true;

                    end; // BIT 2, r


        // BIT 3, r
        %00011000 : begin

                      {
                      S is unknown
                      Z is set if specified bit is 0; reset otherwise
                      H is set
                      P/V is unknown
                      N is reset
                      C is not affected
                      }

                      // SF - bei Bit 0..6 Reset (wie im Emulator)
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %01111111; { Reset SF }

                      // Z is set if specified bit is 0; reset otherwise
                      // P/V wie Z
                      if (var_quell_reg and %00001000) = 0 then begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %01000000; { Set ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000100; { Set PF }
                      end
                      else begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %10111111; { Reset ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111011; { Reset PF }
                      end;


                      // H is set
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00010000; { Set HF }

                      // N is reset
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111101; { Reset NF }


                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'BIT 3,'+quell_string;
                        Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}

                      Befehl_abgearbeitet:=true;

                    end; // BIT 3, r


        // BIT 4, r
        %00100000 : begin

                      {
                      S is unknown
                      Z is set if specified bit is 0; reset otherwise
                      H is set
                      P/V is unknown
                      N is reset
                      C is not affected
                      }

                      // SF - bei Bit 0..6 Reset (wie im Emulator)
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %01111111; { Reset SF }

                      // Z is set if specified bit is 0; reset otherwise
                      // P/V wie Z
                      if (var_quell_reg and %00010000) = 0 then begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %01000000; { Set ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000100; { Set PF }
                      end
                      else begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %10111111; { Reset ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111011; { Reset PF }
                      end;


                      // H is set
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00010000; { Set HF }

                      // N is reset
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111101; { Reset NF }


                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'BIT 4,'+quell_string;
                        Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}

                      Befehl_abgearbeitet:=true;

                    end; // BIT 4, r


        // BIT 5, r
        %00101000 : begin

                      {
                      S is unknown
                      Z is set if specified bit is 0; reset otherwise
                      H is set
                      P/V is unknown
                      N is reset
                      C is not affected
                      }

                      // SF - bei Bit 0..6 Reset (wie im Emulator)
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %01111111; { Reset SF }

                      // Z is set if specified bit is 0; reset otherwise
                      // P/V wie Z
                      if (var_quell_reg and %00100000) = 0 then begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %01000000; { Set ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000100; { Set PF }
                      end
                      else begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %10111111; { Reset ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111011; { Reset PF }
                      end;


                      // H is set
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00010000; { Set HF }

                      // N is reset
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111101; { Reset NF }


                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'BIT 5,'+quell_string;
                        Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}

                      Befehl_abgearbeitet:=true;

                    end; // BIT 5, r


        // BIT 6, r
        %00110000 : begin

                      {
                      S is unknown
                      Z is set if specified bit is 0; reset otherwise
                      H is set
                      P/V is unknown
                      N is reset
                      C is not affected
                      }

                      // SF - bei Bit 0..6 Reset (wie im Emulator)
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %01111111; { Reset SF }

                      // Z is set if specified bit is 0; reset otherwise
                      // P/V wie Z
                      if (var_quell_reg and %01000000) = 0 then begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %01000000; { Set ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000100; { Set PF }
                      end
                      else begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %10111111; { Reset ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111011; { Reset PF }
                      end;


                      // H is set
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00010000; { Set HF }

                      // N is reset
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111101; { Reset NF }


                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'BIT 6,'+quell_string;
                        Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}

                      Befehl_abgearbeitet:=true;

                    end; // BIT 6, r



        // BIT 7, r
        %00111000 : begin

                      {
                      S is unknown
                      Z is set if specified bit is 0; reset otherwise
                      H is set
                      P/V is unknown
                      N is reset
                      C is not affected
                      }


                      // SF - bei Bit 7 Set (wie im Emulator)
                      Sign_Flag_negative(var_quell_reg);


                      // Z is set if specified bit is 0; reset otherwise
                      // P/V wie Z (wie im Emulator)
                      if (var_quell_reg and %10000000) = 0 then begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %01000000; { Set ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00000100; { Set PF }
                      end
                      else begin
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %10111111; { Reset ZF }
                        mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111011; { Reset PF }
                      end;


                      // H is set
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F or %00010000; { Set HF }

                      // N is reset
                      mod_cpu.Reg.HRS.F:=mod_cpu.Reg.HRS.F and %11111101; { Reset NF }


                      {$IFDEF mit_GUI}
                      if Mode_Protokoll then begin

                        Befehl_Zeile := 'BIT 7,'+quell_string;
                        Form_cpu.Reg_Red.HRS.F:=Farbe_Schreiben;

                      end; { if Mode_Protokoll then }
                      {$ENDIF}

                      Befehl_abgearbeitet:=true;

                    end; // BIT 7, r


    end; { case ziel_bit of }



  end; { procedure OP_Code_CB_01 }






  procedure OP_Code_CB_10;
  var
    quell_reg, ziel_bit, var_ziel_bit, Wert_n : Byte;
    Wert_Word : Word;
    bit_string : String;
  begin


    // RES b, r - Reset Bit
    ziel_bit := OP_Code AND %00111000;

    case ziel_bit of

      // RES 0, r
      %00000000 : begin

                    var_ziel_bit := %11111110;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '0';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 0, r


      // RES 1, r
      %00001000 : begin

                    var_ziel_bit := %11111101;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '1';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 1, r


      // RES 2, r
      %00010000 : begin

                    var_ziel_bit := %11111011;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '2';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 2, r


      // RES 3, r
      %00011000 : begin

                    var_ziel_bit := %11110111;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '3';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 3, r


      // RES 4, r
      %00100000 : begin

                    var_ziel_bit := %11101111;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '4';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 4, r


      // RES 5, r
      %00101000 : begin

                    var_ziel_bit := %11011111;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '5';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 5, r


      // RES 6, r
      %00110000 : begin

                    var_ziel_bit := %10111111;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '6';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 6, r


      // RES 7, r
      %00111000 : begin

                    var_ziel_bit := %01111111;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '7';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 7, r


    end; { case ziel_bit of }



    // RES b, r
    quell_reg := OP_Code AND %00000111;

    case quell_reg of

      // RES b, A
      %00000111 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.A := mod_cpu.Reg.HRS.A and var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'RES '+bit_string+', A';
                      Form_cpu.Reg_Red.HRS.A:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // RES b, A


      // RES b, B
      %00000000 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.B := mod_cpu.Reg.HRS.B and var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'RES '+bit_string+', B';
                      Form_cpu.Reg_Red.HRS.B:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // RES b, B


      // RES b, C
      %00000001 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.C := mod_cpu.Reg.HRS.C and var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'RES '+bit_string+', C';
                      Form_cpu.Reg_Red.HRS.C:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // RES b, C


      // RES b, D
      %00000010 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.D := mod_cpu.Reg.HRS.D and var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'RES '+bit_string+', D';
                      Form_cpu.Reg_Red.HRS.D:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // RES b, D


      // RES b, E
      %00000011 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.E := mod_cpu.Reg.HRS.E and var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'RES '+bit_string+', E';
                      Form_cpu.Reg_Red.HRS.E:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // RES b, E


      // RES b, H
      %00000100 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.H := mod_cpu.Reg.HRS.H and var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'RES '+bit_string+', H';
                      Form_cpu.Reg_Red.HRS.H:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // RES b, H


      // RES b, L
      %00000101 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.L := mod_cpu.Reg.HRS.L and var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'RES '+bit_string+', L';
                      Form_cpu.Reg_Red.HRS.L:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // RES b, L



      // RES b, (HL)
      %00000110 : begin
                    {
                    Condition Bits Affected: None
                    }

                    Wert_Word := (mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L;
                    Wert_n := mod_ram.Read_Byte(Wert_Word); // (HL) -> Wert_n

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      Form_RAM.setze_Mem_Red(Wert_Word);    // HL
                    end;
                    {$ENDIF}

                    // RES b, (HL)
                    Wert_n := Wert_n and var_ziel_bit;

                    // Wert_n -> (HL)
                    mod_ram.Write_Byte(Wert_Word, Wert_n);

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'RES '+bit_string+', (HL)';
                      Form_cpu.Reg_Red.HRS.HL_Inhalt:=Farbe_Schreiben;
                      Form_cpu.Reg_Red.HRS.HL:=Farbe_Lesen;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // RES b, (HL)


    end; { case quell_reg of }


  end; { procedure OP_Code_CB_10 }






  procedure OP_Code_CB_11;
  var
    quell_reg, ziel_bit, var_ziel_bit, Wert_n : Byte;
    Wert_Word : Word;
    bit_string : String;
  begin


    // SET b, r - Set Bit
    ziel_bit := OP_Code AND %00111000;

    case ziel_bit of

      // SET 0, r
      %00000000 : begin

                    var_ziel_bit := %00000001;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '0';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 0, r


      // SET 1, r
      %00001000 : begin

                    var_ziel_bit := %00000010;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '1';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 1, r


      // SET 2, r
      %00010000 : begin

                    var_ziel_bit := %00000100;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '2';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 2, r


      // SET 3, r
      %00011000 : begin

                    var_ziel_bit := %00001000;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '3';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 3, r


      // SET 4, r
      %00100000 : begin

                    var_ziel_bit := %00010000;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '4';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 4, r


      // SET 5, r
      %00101000 : begin

                    var_ziel_bit := %00100000;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '5';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 5, r


      // SET 6, r
      %00110000 : begin

                    var_ziel_bit := %01000000;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '6';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 6, r


      // SET 7, r
      %00111000 : begin

                    var_ziel_bit := %10000000;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      bit_string := '7';
                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                  end; // SET 7, r


    end; { case ziel_bit of }



    // SET b, r
    quell_reg := OP_Code AND %00000111;

    case quell_reg of

      // SET b, A
      %00000111 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.A := mod_cpu.Reg.HRS.A or var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'SET '+bit_string+', A';
                      Form_cpu.Reg_Red.HRS.A:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // SET b, A


      // SET b, B
      %00000000 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.B := mod_cpu.Reg.HRS.B or var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'SET '+bit_string+', B';
                      Form_cpu.Reg_Red.HRS.B:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // SET b, B


      // SET b, C
      %00000001 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.C := mod_cpu.Reg.HRS.C or var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'SET '+bit_string+', C';
                      Form_cpu.Reg_Red.HRS.C:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // SET b, C


      // SET b, D
      %00000010 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.D := mod_cpu.Reg.HRS.D or var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'SET '+bit_string+', D';
                      Form_cpu.Reg_Red.HRS.D:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // SET b, D


      // SET b, E
      %00000011 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.E := mod_cpu.Reg.HRS.E or var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'SET '+bit_string+', E';
                      Form_cpu.Reg_Red.HRS.E:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // SET b, E


      // SET b, H
      %00000100 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.H := mod_cpu.Reg.HRS.H or var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'SET '+bit_string+', H';
                      Form_cpu.Reg_Red.HRS.H:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // SET b, H


      // SET b, L
      %00000101 : begin
                    {
                    Condition Bits Affected: None
                    }

                    mod_cpu.Reg.HRS.L := mod_cpu.Reg.HRS.L or var_ziel_bit;

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'SET '+bit_string+', L';
                      Form_cpu.Reg_Red.HRS.L:=Farbe_Schreiben;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // SET b, L



      // SET b, (HL)
      %00000110 : begin
                    {
                    Condition Bits Affected: None
                    }

                    Wert_Word := (mod_cpu.Reg.HRS.H shl 8) + mod_cpu.Reg.HRS.L;
                    Wert_n := mod_ram.Read_Byte(Wert_Word); // (HL) -> Wert_n

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin
                      Form_RAM.setze_Mem_Red(Wert_Word);    // HL
                    end;
                    {$ENDIF}

                    // SET b, (HL)
                    Wert_n := Wert_n or var_ziel_bit;

                    // Wert_n -> (HL)
                    mod_ram.Write_Byte(Wert_Word, Wert_n);

                    {$IFDEF mit_GUI}
                    if Mode_Protokoll then begin

                      Befehl_Zeile := 'SET '+bit_string+', (HL)';
                      Form_cpu.Reg_Red.HRS.HL_Inhalt:=Farbe_Schreiben;
                      Form_cpu.Reg_Red.HRS.HL:=Farbe_Lesen;

                    end; { if Mode_Protokoll then }
                    {$ENDIF}

                    Befehl_abgearbeitet:=true;

                  end; // SET b, (HL)


    end; { case quell_reg of }


  end; { procedure OP_Code_CB_11 }





  procedure OP_Code_CB;
  var
    OP_Code2 : Byte;
  begin

    {$IFDEF mit_GUI}
    if Mode_Protokoll then
      Form_RAM.setze_Mem_Green(mod_cpu.Reg.SRS.PC);
    {$ENDIF}

    OP_Code := mod_ram.Read_Byte(mod_cpu.Reg.SRS.PC);
    INC(mod_cpu.Reg.SRS.PC);

    OP_Code2 := OP_Code AND %11000000;

    case OP_Code2 of

      %00000000 : OP_Code_CB_00;

      %01000000 : OP_Code_CB_01;

      %10000000 : OP_Code_CB_10;

      %11000000 : OP_Code_CB_11;

    end; { case temp_op_code of }

  end; { procedure OP_Code_CB }






